#****************************************************************************
#**  File     :  /lua/sim/Projectile.lua
#****************************************************************************

local oldProjectile = Projectile
Projectile = Class(oldProjectile) {
	
#OnLostTarget = function(self)
#    if (self:GetBlueprint().Physics.TrackTarget) and (self.antiair or self.antinavy) then
#    	self:Retarget()
#    end
#         self:TrackTarget(true) 
#         self:SetTurnRate(180)
#               self:SetLifetime(3)
#    oldProjectile.OnLostTarget(self)
#end,

OnCreate = function(self)
	oldProjectile.OnCreate(self)
	if (self:GetBlueprint().Physics.TrackTarget) then
		self:ForkThread(self.StartSpread)
	end
end, 

StartSpread = function(self)
	if (self:GetBlueprint().Physics.TrackTarget) and (self.antiair or self.antinavy) then
		#LOG('oncreate',self.antiair,self.antinavy,self.range)
		local target = self:GetTrackingTarget()
		if target then
			if target.IncommingDamage == nil then
				target.IncommingDamage=self.DamageData.DamageAmount
			elseif (target.IncommingDamage)>=(target:GetHealth()*1.2) then 
				self:Retarget()
			else
				target.IncommingDamage=target.IncommingDamage+self.DamageData.DamageAmount
			end
		else
			self:Retarget()
		end
		#self:ForkThread(self.LifetimeCounter)
	end
end,

LifetimeCounter = function(self)
	while not self:BeenDestroyed() do
		local target = self:GetTrackingTarget()
		WaitSeconds(1) 
	                if target and target:IsDead() then	
			self:Retarget()
		end
	end
end,
    
Retarget = function(self)
	self.lock = 0
	local launcher = self:GetLauncher()
	local aiBrain = launcher:GetAIBrain()
	local position = self:GetPosition()
	local radius = self.range
	local targetlist = {}
	if self.antiair then
		targetlist = aiBrain:GetUnitsAroundPoint(categories.AIR, position, radius, 'ENEMY')
	elseif self.antinavy then
		targetlist = aiBrain:GetUnitsAroundPoint(categories.NAVAL, position, radius, 'ENEMY')
#print(table.getsize(targetlist))
	end
	if  targetlist[1] then
		local mindtarget = targetlist[1]
		for _, target in targetlist do
			if target.IncommingDamage and target.IncommingDamage<=(target:GetHealth()*1.2)  then
				self:SetNewTarget(target)
				target.IncommingDamage=target.IncommingDamage+self.DamageData.DamageAmount
				self.lock = 1
				return
			elseif target.IncommingDamage == nil  then 
				self:SetNewTarget(target)
				target.IncommingDamage=self.DamageData.DamageAmount
				self.lock = 2
				return
			end
			if (target.IncommingDamage/target:GetHealth()) < (mindtarget.IncommingDamage/mindtarget:GetHealth()) then
				mindtarget = target
			end
		end
		self:SetNewTarget(mindtarget)
		mindtarget.IncommingDamage=mindtarget.IncommingDamage+self.DamageData.DamageAmount
		self.lock = 3
	end
end,

OnDestroy = function(self)
	local target = self:GetTrackingTarget()
    	if target and target.IncommingDamage then #
		target.IncommingDamage=target.IncommingDamage-self.DamageData.DamageAmount
		if target.IncommingDamage<=0 then
    			target.IncommingDamage=nil
		end
	end	
	if not (oldProjectile.OnDestroy==nil) then
		oldProjectile.OnDestroy(self)
	end
end,

    OnCollisionCheck = function(self,other)
        if IsAlly(self:GetArmy(), other:GetArmy()) then
                return false
        end
	oldProjectile.OnCollisionCheck(self,other)
    end,
}
