#****************************************************************************
#**
#**  File     :  /lua/sim/Weapon.lua
#**  Author(s):  John Comes
#**
#**  Summary  : The base weapon class for all weapons in the game.
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local oldWeapon = Weapon
Weapon = Class(oldWeapon) {
   CreateProjectileForWeapon = function(self, bone)
    	local proj = oldWeapon.CreateProjectileForWeapon(self, bone)
    	local bp = self:GetBlueprint()
    	proj.range = bp.MaxRadius
    	if bp.WeaponCategory == 'Anti Air' then
    		proj.antiair = true
    	elseif bp.WeaponCategory == 'Anti Navy' then
		proj.antinavy = true
	end
    	return proj
    end,
}
