do

    local CBFP_oldModBlueprints = ModBlueprints
    function ModBlueprints(all_bps)
        CBFP_oldModBlueprints(all_bps)
        for id, bp in all_bps.Unit do
            if not bp.ResolvePath then # skip blueprints that don't have this set for perfomance reasons
                continue
            end
            bp = ResolvePaths(bp)
        end
    end

    # finds a path that starts with [...] , finds the specified file and then corrects the path
    function ResolvePaths(bpTable)
        for k, v in bpTable do
            if type(v) == 'table' then
                bpTable[k] = ResolvePaths(v)
                continue
            elseif type(v) != 'string' or string.len(v) < 8 or string.sub(v, 1, 5) != '[...]' then
                continue
            end
            local partialPath = string.sub(v, 6) # v needs to be > 6 for this, checking v >= 8 two lines up
            local path = ''
            local foundResult = false
            LOG('Resolving full path for '..repr(partialPath))
            for i, m in __active_mods do
                for _,file in DiskFindFiles(m.location, partialPath) do
                    path = file
                    foundResult = true
                    break
                end
                if foundResult then
                    break
                end
            end
            if not foundResult then
                WARN('Cannot resolve full path for partial path '..repr(partialPath))
                continue
            end
            bpTable[k] = path
        end
        return bpTable
    end
#####################################################################################
	local oldModBlueprints = ModBlueprints
	function ModBlueprints(all_bps)
		oldModBlueprints(all_bps)

		for id, bp in all_bps.Unit do

			if bp.Air and table.find(bp.Categories,'BOMBER') and not(table.find(bp.Categories,'EXPERIMENTAL')) then
				if bp.Air.BreakOffDistance then bp.Air.BreakOffDistance=(bp.Air.BreakOffDistance*1.3) end
				if bp.Air.BreakOffTrigger then bp.Air.BreakOffTrigger=(bp.Air.BreakOffTrigger*1.3) end 
			end
			if bp.Air and table.find(bp.Categories,'SERAPHIM') and table.find(bp.Categories,'HIGHALTAIR') and table.find(bp.Categories,'EXPERIMENTAL') then
				if bp.Air.BreakOffDistance then bp.Air.BreakOffDistance=(bp.Air.BreakOffDistance*1.5) end
				if bp.Air.BreakOffTrigger then bp.Air.BreakOffTrigger=(bp.Air.BreakOffTrigger*1.5) end 
			end

			if bp.Weapon then
				for ik, wep in bp.Weapon do
					if wep.MaxRadius and wep.TargetRestrictOnlyAllow and (wep.TargetRestrictOnlyAllow=='TACTICAL MISSILE'  or wep.TargetRestrictOnlyAllow=='TACTICAL,MISSILE')then
						if table.find(bp.Categories,'CYBRAN') then
							wep.RateOfFire = wep.RateOfFire*2
							wep.MaxRadius = math.floor(wep.MaxRadius * 0.5)
						elseif table.find(bp.Categories,'AEON') then
							wep.RateOfFire = wep.RateOfFire*2
							#wep.TrackingRadius = 2
							wep.MuzzleVelocity = wep.MuzzleVelocity*2
						elseif table.find(bp.Categories,'UEF') then
							wep.MaxRadius = math.floor(wep.MaxRadius * 0.75)
							wep.RateOfFire = wep.RateOfFire*1.5
						elseif table.find(bp.Categories,'SERAPHIM') then
							wep.MuzzleVelocity=math.floor(wep.MuzzleVelocity*2)
						end
					elseif (wep.ContinuousBeam or wep.BeamLifetime)and(bp.BlueprintId~='xea0002')and(bp.BlueprintId~='uaa0310')and(wep.Damage>1)and(not(table.find(bp.Categories,'COMMAND'))) then
						LOG('*CIP: beamMod ' .. bp.BlueprintId .. '  ' .. bp.Description)
						wep.MaxRadius = math.floor(wep.MaxRadius * 1.5)
						wep.DamageLossMod = 2
					elseif (wep.ContinuousBeam or wep.BeamLifetime)and(wep.DamageType~='Overcharge')and(table.find(bp.Categories,'COMMAND')) then
						LOG('*CIP: beamMod ' .. bp.BlueprintId .. '  ' .. bp.Description)
						wep.DamageLossMod = 3
					end
				end
			end
		
			if bp.Wreckage and bp.Wreckage.HealthMult then
				bp.Wreckage.HealthMult	=	10
			end
			
		end	--	all_bps.Unit loop
	end	--	ModBlueprints

end




