#
# Aeon Very Fast Anti-Missile Missile
#
local AIMFlareProjectile = import('/lua/aeonprojectiles.lua').AIMFlareProjectile
local Entity = import('/lua/sim/Entity.lua').Entity
Flare = Class(Entity) {

    OnCreate = function(self, spec)
        self.Owner = spec.Owner
        self.Radius = spec.Radius or 40
        self:SetCollisionShape('Sphere', 0, 0, 0, self.Radius)
        self:SetDrawScale(self.Radius)
        self:AttachTo(spec.Owner, -1)
        self.RedirectCat = spec.Category or 'MISSILE'
    end,

    # We only divert projectiles. The flare-projectile itself will be responsible for
    # accepting the collision and causing the hostile projectile to impact.
    OnCollisionCheck = function(self,other)
                    if EntityCategoryContains(categories.ANTIMISSILE, other) and IsEnemy( self:GetArmy(), other:GetArmy() ) then
            #LOG('*DEBUG FLARE COLLISION CHECK')
            other:SetNewTarget(self.Owner)
        end
        return false
    end,
}

AIMAntiAntiNuke01 = Class(AIMFlareProjectile) {
    --[[OnCreate = function(self)
            local antiMissile = Flare {
            Owner = self,
            Radius = 50,
            AttachBone = 'AIMAntiAntiNuke01',
        }]]--
        AIMFlareProjectile.OnCreate(self)
        self:SetCollisionShape('Sphere', 0, 0, 0, 1.0)
    end,
}

TypeClass = AIMAntiAntiNuke01

