#****************************************************************************
#**
#**  File     :  /cdimage/units/UAB4302/UAB4302_script.lua
#**  Author(s):  John Comes, David Tomandl, Jessica St. Croix
#**
#**  Summary  :  Aeon Strategic Missile Defense Script
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local AStructureUnit = import('/lua/aeonunits.lua').AStructureUnit
local AAMSaintWeapon = import('/lua/aeonweapons.lua').AAMSaintWeapon

UAB4302 = Class(AStructureUnit) {

    Weapons = {
        MissileRack = Class(AAMSaintWeapon) {
            IdleState = State(AAMSaintWeapon.IdleState) {
                OnGotTarget = function(self)
                end,
                OnFire = function(self)
	    local target = self:GetCurrentTarget()
                    if (target.incomingProjectiles == nil)or(target.incomingProjectiles <= target.Charges) then
		if target.incomingProjectiles == nil then
			target.incomingProjectiles=1
		else
			target.incomingProjectiles=target.incomingProjectiles+1
		end
                        AAMSaintWeapon.IdleState.OnFire(self)
	    end
                    
                    self:ForkThread(function()
                        self.unit:SetBusy(true)
                        WaitSeconds(1/self.unit:GetBlueprint().Weapon[1].RateOfFire + .2)
                        self.unit:SetBusy(false)
                    end)
                end,
            },
            },
       AntiAir = Class(AAMSaintWeapon) {
            IdleState = State(AAMSaintWeapon.IdleState) {
                OnGotTarget = function(self)
	    local target = self:GetCurrentTarget()
                    if ((target.IncommingDamage==nil)or(target.IncommingDamage<target:GetHealth())) then
LOG(target.IncommingDamage,'=====',target:GetHealth())
		if target.IncommingDamage == nil then
			target.IncommingDamage=5000
		else
			target.IncommingDamage=target.IncommingDamage+5000
		end
                   	 self:ForkThread(function()
			WaitSeconds(5)
			if target.IncommingDamage!=nil then
				target.IncommingDamage=target.IncommingDamage-5000
				if target.IncommingDamage<=0 then
    					target.IncommingDamage=nil
				end
			end
                    	end)
                        AAMSaintWeapon.IdleState.OnGotTarget(self)
	    end
                    
                    self:ForkThread(function()
                        self.unit:SetBusy(true)
                        WaitSeconds(1/self.unit:GetBlueprint().Weapon[1].RateOfFire + .2)
                        self.unit:SetBusy(false)
                    end)
                end,

                OnFire = function(self)
	    local target = self:GetCurrentTarget()
                    if ((target.IncommingDamage==nil)or(target.IncommingDamage<target:GetHealth())) then
LOG(target.IncommingDamage,'=====',target:GetHealth())
		if target.IncommingDamage == nil then
			target.IncommingDamage=5000
		else
			target.IncommingDamage=target.IncommingDamage+5000
		end
                   	 self:ForkThread(function()
			WaitSeconds(5)
			if target.IncommingDamage!=nil then
				target.IncommingDamage=target.IncommingDamage-5000
				if target.IncommingDamage<=0 then
    					target.IncommingDamage=nil
				end
			end
                    	end)
                        AAMSaintWeapon.IdleState.OnFire(self)
	    end
                    
                    self:ForkThread(function()
                        self.unit:SetBusy(true)
                        WaitSeconds(1/self.unit:GetBlueprint().Weapon[1].RateOfFire + .2)
                        self.unit:SetBusy(false)
                    end)
                end,
            },
            },
    },
    OnCreate = function(self)
        AStructureUnit.OnCreate(self)
        self:SetWeaponEnabledByLabel('AntiAir', false)
    end,
    
    OnScriptBitSet = function(self, bit)
        AStructureUnit.OnScriptBitSet(self, bit)
        if bit == 1 then 
            self:SetWeaponEnabledByLabel('AntiAir', true)
        end
    end,

    OnScriptBitClear = function(self, bit)
        AStructureUnit.OnScriptBitClear(self, bit)
        if bit == 1 then 
            self:SetWeaponEnabledByLabel('AntiAir', false)
        end
    end,
}

TypeClass = UAB4302