#****************************************************************************
#**
#**  File     :  /cdimage/units/UEB4302/UEB4302_script.lua
#**  Author(s):  John Comes, David Tomandl, Jessica St. Croix
#**
#**  Summary  :  UEF Strategic Missile Defense Script
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local TStructureUnit = import('/lua/terranunits.lua').TStructureUnit
local TAMInterceptorWeapon = import('/lua/terranweapons.lua').TAMInterceptorWeapon

UEB4302 = Class(TStructureUnit) {
    Weapons = {
        MissileRack = Class(TAMInterceptorWeapon) {
            IdleState = State(TAMInterceptorWeapon.IdleState) {
                OnGotTarget = function(self)

                end,
                OnFire = function(self)
	    local target = self:GetCurrentTarget()
	    if (target.incomingProjectiles == nil) then target.incomingProjectiles = 0 end
                    if (target.Charges != nil) and (target.incomingProjectiles <= target.Charges) then
	        target.incomingProjectiles = target.incomingProjectiles+1
                        TAMInterceptorWeapon.IdleState.OnFire(self)
	    end
                    
                    self:ForkThread(function()
                        self.unit:SetBusy(true)
                        WaitSeconds(1/self.unit:GetBlueprint().Weapon[1].RateOfFire + .2)
                        self.unit:SetBusy(false)
                    end)
                end,
            },
            },
       AntiAir = Class(TAMInterceptorWeapon) {
            IdleState = State(TAMInterceptorWeapon.IdleState) {
                OnGotTarget = function(self)
	    local target = self:GetCurrentTarget()
                    if ((target.IncommingDamage==nil)or(target.IncommingDamage<target:GetHealth())) then
LOG(target.IncommingDamage,'=====',target:GetHealth())
		if target.IncommingDamage == nil then
			target.IncommingDamage=5000
		else
			target.IncommingDamage=target.IncommingDamage+5000
		end
                   	 self:ForkThread(function()
			WaitSeconds(5)
			if target.IncommingDamage!=nil then
				target.IncommingDamage=target.IncommingDamage-5000
				if target.IncommingDamage<=0 then
    					target.IncommingDamage=nil
				end
			end
                    	end)
                        TAMInterceptorWeapon.IdleState.OnGotTarget(self)
	    end
                    
                    self:ForkThread(function()
                        self.unit:SetBusy(true)
                        WaitSeconds(1/self.unit:GetBlueprint().Weapon[1].RateOfFire + .2)
                        self.unit:SetBusy(false)
                    end)
                end,

                OnFire = function(self)
	    local target = self:GetCurrentTarget()
                    if ((target.IncommingDamage==nil)or(target.IncommingDamage<target:GetHealth())) then
LOG(target.IncommingDamage,'=====',target:GetHealth())
		if target.IncommingDamage == nil then
			target.IncommingDamage=5000
		else
			target.IncommingDamage=target.IncommingDamage+5000
		end
                   	 self:ForkThread(function()
			WaitSeconds(5)
			if target.IncommingDamage!=nil then
				target.IncommingDamage=target.IncommingDamage-5000
				if target.IncommingDamage<=0 then
    					target.IncommingDamage=nil
				end
			end
                    	end)
                        TAMInterceptorWeapon.IdleState.OnFire(self)
	    end
                    
                    self:ForkThread(function()
                        self.unit:SetBusy(true)
                        WaitSeconds(1/self.unit:GetBlueprint().Weapon[1].RateOfFire + .2)
                        self.unit:SetBusy(false)
                    end)
                end,
            },
            },
    },
    OnCreate = function(self)
        TStructureUnit.OnCreate(self)
        self:SetWeaponEnabledByLabel('AntiAir', false)
    end,
    
    OnScriptBitSet = function(self, bit)
        TStructureUnit.OnScriptBitSet(self, bit)
        if bit == 1 then 
            self:SetWeaponEnabledByLabel('AntiAir', true)
        end
    end,

    OnScriptBitClear = function(self, bit)
        TStructureUnit.OnScriptBitClear(self, bit)
        if bit == 1 then 
            self:SetWeaponEnabledByLabel('AntiAir', false)
        end
    end,
}

TypeClass = UEB4302