#****************************************************************************
#**
#**  File     :  /cdimage/units/URB4302/URB4302_script.lua
#**  Author(s):  John Comes, David Tomandl, Jessica St. Croix
#**
#**  Summary  :  Cybran Strategic Missile Defense Script
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local CStructureUnit = import('/lua/cybranunits.lua').CStructureUnit
local CAMEMPMissileWeapon = import('/lua/cybranweapons.lua').CAMEMPMissileWeapon
local EffectTemplate = import('/lua/EffectTemplates.lua')


URB4302 = Class(CStructureUnit) {
    Weapons = {
        MissileRack = Class(CAMEMPMissileWeapon) {
            FxMuzzleFlash = EffectTemplate.CAntiNukeLaunch01,
            IdleState = State(CAMEMPMissileWeapon.IdleState) {
                OnGotTarget = function(self)

                end,
                OnFire = function(self)
	    local target = self:GetCurrentTarget()
                    if (target.incomingProjectiles == nil)or(target.incomingProjectiles <= target.Charges) then
		if target.incomingProjectiles == nil then
			target.incomingProjectiles=1
		else
			target.incomingProjectiles=target.incomingProjectiles+1
		end
                        CAMEMPMissileWeapon.IdleState.OnFire(self)
	    end
                    
                    self:ForkThread(function()
                        self.unit:SetBusy(true)
                        WaitSeconds(1/self.unit:GetBlueprint().Weapon[1].RateOfFire + .2)
                        self.unit:SetBusy(false)
                    end)
                end,
            },
            },
       AntiAir = Class(CAMEMPMissileWeapon) {
            FxMuzzleFlash = EffectTemplate.CAntiNukeLaunch01,
            IdleState = State(CAMEMPMissileWeapon.IdleState) {
                OnGotTarget = function(self)
	    local target = self:GetCurrentTarget()
                    if ((target.IncommingDamage==nil)or(target.IncommingDamage<target:GetHealth())) then
		if target.IncommingDamage == nil then
			target.IncommingDamage=5000
		else
			target.IncommingDamage=target.IncommingDamage+5000
		end
                   	 self:ForkThread(function()
			WaitSeconds(5)
			if target.IncommingDamage!=nil then
				target.IncommingDamage=target.IncommingDamage-5000
				if target.IncommingDamage<=0 then
    					target.IncommingDamage=nil
				end
			end
                    	end)
                        CAMEMPMissileWeapon.IdleState.OnGotTarget(self)
	    end
                    
                    self:ForkThread(function()
                        self.unit:SetBusy(true)
                        WaitSeconds(1/self.unit:GetBlueprint().Weapon[1].RateOfFire + .2)
                        self.unit:SetBusy(false)
                    end)
                end,

                OnFire = function(self)
	    local target = self:GetCurrentTarget()
                    if ((target.IncommingDamage==nil)or(target.IncommingDamage<target:GetHealth())) then
		if target.IncommingDamage == nil then
			target.IncommingDamage=5000
		else
			target.IncommingDamage=target.IncommingDamage+5000
		end
                   	 self:ForkThread(function()
			WaitSeconds(5)
			if target.IncommingDamage!=nil then
				target.IncommingDamage=target.IncommingDamage-5000
				if target.IncommingDamage<=0 then
    					target.IncommingDamage=nil
				end
			end
                    	end)
                        CAMEMPMissileWeapon.IdleState.OnFire(self)
	    end
                    
                    self:ForkThread(function()
                        self.unit:SetBusy(true)
                        WaitSeconds(1/self.unit:GetBlueprint().Weapon[1].RateOfFire + .2)
                        self.unit:SetBusy(false)
                    end)
                end,
            },
            },
    },
    OnCreate = function(self)
        CStructureUnit.OnCreate(self)
        self:SetWeaponEnabledByLabel('AntiAir', false)
    end,
    
    OnScriptBitSet = function(self, bit)
        CStructureUnit.OnScriptBitSet(self, bit)
        if bit == 1 then 
            self:SetWeaponEnabledByLabel('AntiAir', true)
        end
    end,

    OnScriptBitClear = function(self, bit)
        CStructureUnit.OnScriptBitClear(self, bit)
        if bit == 1 then 
            self:SetWeaponEnabledByLabel('AntiAir', false)
        end
    end,
}

TypeClass = URB4302